if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_CombatIcon requires PitBull4")
end

local L = PitBull4.L

local PitBull4_DogTagTexts = PitBull4:NewModule("DogTagTexts")

local LibDogTag

PitBull4_DogTagTexts:SetModuleType("text_provider")
PitBull4_DogTagTexts:SetName(L["DogTag-3.0 texts"])
PitBull4_DogTagTexts:SetDescription(L["Text provider for LibDogTag-3.0 texts."])
PitBull4_DogTagTexts:SetDefaults({
	texts = {
		['**'] = {
			size = 1,
			attach_to = "root",
			location = "edge_top_left",
			position = 1,
			code = "",
		},
		n = 10,
		{
			name = L["Name"],
			code = "[Name] [(AFK or DND):Angle]",
			attach_to = "HealthBar",
			location = "left"
		},
		{
			name = L["Health"],
			code = "[Status or (if IsFriend then MissingHP:Hide(0):Short:Color('ff7f7f') else FractionalHP(known=true):Short or PercentHP:Percent)]",
			attach_to = "HealthBar",
			location = "right",
		},
		{
			name = L["Class"],
			code = "[Classification] [Level:DifficultyColor] [(if (IsPlayer or (IsEnemy and not IsPet)) then Class):ClassColor] [DruidForm:Paren] [SmartRace]",
			attach_to = "PowerBar",
			location = "left",
		},
		{
			name = L["Power"],
			code = "[if HasMP then FractionalMP]",
			attach_to = "PowerBar",
			location = "right",
		},
		{
			name = L["Reputation"],
			code = "[if IsMouseOver then ReputationName else if ReputationName then FractionalReputation ' ' PercentReputation:Percent:Paren]",
			attach_to = "ReputationBar",
			location = "center",
		},
		{
			name = L["Cast"],
			code = "[Alpha((-CastStopDuration or 0) + 1) CastStopMessage or (CastName ' ' CastTarget:Paren)]",
			attach_to = "CastBar",
			location = "left",
		},
		{
			name = L["Cast time"],
			code = "[if not CastStopDuration then Concatenate('+', CastDelay:Round(1):Hide(0)):Red ' ' [CastEndDuration >= 0 ? '%.1f':Format(CastEndDuration)]]",
			attach_to = "CastBar",
			location = "right",
		},
		{
			name = L["Experience"],
			code = "[FractionalXP] [PercentXP:Percent:Paren] [Concatenate('R: ', PercentRestXP:Hide(0):Percent)]",
			attach_to = "ExperienceBar",
			location = "center",
		},
		{
			name = L["Threat"],
			code = "[PercentThreat:Short:Hide(0):Percent]",
			attach_to = "ThreatBar",
			location = "center",
		},
		{
			name = L["Druid mana"],
			code = "[if not IsMana then FractionalDruidMP]",
			attach_to = "DruidManaBar",
			location = "right",
		}
	},
})

local PROVIDED_CODES = function() return {
	[L["Class"]] = {
		[L["Standard"]]            = "[Classification] [Level:DifficultyColor] [(if (IsPlayer or (IsEnemy and not IsPet)) then Class):ClassColor] [DruidForm:Paren] [SmartRace]",
		[L["Player classes only"]] = "[Classification] [Level:DifficultyColor] [(if IsPlayer then Class):ClassColor] [DruidForm:Paren] [SmartRace]",
		[L["Short"]]               = "[(Level (if Classification then '+')):DifficultyColor] [SmartRace]",
	},
	[L["Health"]] = {
		[L["Absolute"]]       = "[Status or FractionalHP(known=true) or PercentHP:Percent]",
		[L["Absolute short"]] = "[Status or FractionalHP(known=true):Short or PercentHP:Percent]",
		[L["Difference"]]     = "[Status or -MissingHP:Hide(0)]",
		[L["Percent"]]        = "[Status or PercentHP:Percent]",
		[L["Mini"]]           = "[HP:VeryShort]",
		[L["Smart"]]          = "[Status or (if IsFriend then MissingHP:Hide(0):Short:Color('ff7f7f') else FractionalHP(known=true):Short or PercentHP:Percent)]",
		[L["Absolute and percent"]]  = "[Status or (FractionalHP:Short ' || ' PercentHP:Percent)]",
		[L["Informational"]]  = "[Status or (Concatenate((if IsFriend then MissingHP:Hide(0):Short:Color('ff7f7f')), ' || ') FractionalHP:Short ' || ' PercentHP:Percent)]",
	},
	[L["Name"]] = {
		[L["Standard"]]             = "[Name] [(AFK or DND):Angle]",
		[L["Hostility-colored"]]    = "[Name:HostileColor] [(AFK or DND):Angle]",
		[L["Class-colored"]]        = "[Name:ClassColor] [(AFK or DND):Angle]",
		[L["Long"]]                 = "[Level] [Name:ClassColor] [(AFK or DND):Angle]",
		[L["Long w/ Druid form"]]   = "[Level] [Name:ClassColor] [DruidForm:Paren] [(AFK or DND):Angle]",
	},
	[L["Power"]] = {
		[L["Absolute"]]       = "[if HasMP then FractionalMP]",
		[L["Absolute short"]] = "[if HasMP then FractionalMP:Short]",
		[L["Difference"]]     = "[-MissingMP]",
		[L["Percent"]]        = "[PercentMP:Percent]",
		[L["Mini"]]           = "[if HasMP then CurMP:VeryShort]",
		[L["Smart"]]          = "[MissingMP:Hide(0):Short:Color('7f7fff')]",
	},
	[L["Druid mana"]] = {
		[L["Absolute"]]       = "[if not IsMana then FractionalDruidMP]",
		[L["Absolute short"]] = "[if not IsMana then FractionalDruidMP:Short]",
		[L["Difference"]]     = "[if not IsMana then -MissingDruidMP]",
		[L["Percent"]]        = "[if not IsMana then PercentDruidMP:Percent]",
		[L["Mini"]]           = "[if not IsMana then DruidMP:VeryShort]",
		[L["Smart"]]          = "[if not IsMana then MissingDruidMP:Hide(0):Short:Color('7f7fff')]",
	},
	[L["Threat"]] = {
		[L["Percent"]]            = "[PercentThreat:Short:Hide(0):Percent]",
		[L["Raw percent"]]         = "[RawPercentThreat:Short:Hide(0):Percent]",
		[L["Colored percent"]]    = "[PercentThreat:Short:Hide(0):Percent:ThreatStatusColor(ThreatStatus)]",
		[L["Colored raw percent"]] = "[RawPercentThreat:Short:Hide(0):Percent:ThreatStatusColor(ThreatStatus)]",
	},
	[L["Cast"]] = {
		[L["Standard name"]] = "[Alpha((-CastStopDuration or 0) + 1) CastStopMessage or (CastName ' ' CastTarget:Paren)]",
		[L["Standard time"]] = "[if not CastStopDuration then Concatenate('+', CastDelay:Round(1):Hide(0)):Red ' ' [CastEndDuration >= 0 ? '%.1f':Format(CastEndDuration)]]",
	},
	[L["Combo points"]] = {
		[L["Standard"]]       = playerClass == "DRUID" and "[if IsEnergy(unit='player') then Combos:Hide(0)]" or "[Combos:Hide(0)]",
	},
	[L["Experience"]] = {
		[L["Standard"]]       = "[FractionalXP] [PercentXP:Percent:Paren] [Concatenate('R: ', PercentRestXP:Hide(0):Percent)]",
		[L["On mouse-over"]]       = "[if IsMouseOver then FractionalXP ' ' PercentXP:Percent:Paren ' ' Concatenate('R: ', PercentRestXP:Hide(0):Percent)]",
	},
	[L["Reputation"]] = {
		[L["Standard"]]       = "[if IsMouseOver then ReputationName else if ReputationName then FractionalReputation ' ' PercentReputation:Percent:Paren]"
	},
} end

local function run_first()
	LibDogTag = LibStub("LibDogTag-3.0", true)
	if not LibDogTag then
		LoadAddOn("LibDogTag-3.0")
		LibDogTag = LibStub("LibDogTag-3.0", true)
		if not LibDogTag then
			error("PitBull4_DogTagTexts requires LibDogTag-3.0 to function.")
		end
	end
	local LibDogTag_Unit = LibStub("LibDogTag-Unit-3.0", true)
	if not LibDogTag_Unit then
		LoadAddOn("LibDogTag-Unit-3.0")
		LibDogTag_Unit = LibStub("LibDogTag-Unit-3.0", true)
		if not LibDogTag_Unit then
			error("PitBull4_DogTagTexts requires LibDogTag-Unit-3.0 to function.")
		end
	end
end

local unit_kwargs = setmetatable({}, {__mode='kv', __index=function(self, unit)
	self[unit] = { unit = unit }
	return self[unit]
end})

-- this will replace the normal :AddFontString
function PitBull4_DogTagTexts:_AddFontString(frame, font_string, data)
	if frame.force_show and not frame.guid and (data.name ~= L["Name"] or not frame.unit) then
		LibDogTag:RemoveFontString(font_string)
		font_string:SetText(("[%s]"):format(data.name))
	else
		LibDogTag:AddFontString(
			font_string,
			frame,
			data.code,
			"Unit",
			unit_kwargs[frame.unit])
	end
	return true
end

function PitBull4_DogTagTexts:AddFontString(...)
	run_first()
	
	self.AddFontString = self._AddFontString
	self._AddFontString = nil
	
	return PitBull4_DogTagTexts:AddFontString(...)
end

function PitBull4_DogTagTexts:RemoveFontString(font_string)
	LibDogTag:RemoveFontString(font_string)
end

PitBull4_DogTagTexts:SetLayoutOptionsFunction(function(self)
	local values = {}
	local value_key_to_code = {}
	values[""] = L["Custom"]
	value_key_to_code[""] = ""
	for base, codes in pairs(PROVIDED_CODES()) do
		for name, code in pairs(codes) do
			local key = ("%s: %s"):format(base, name)
			values[key] = key
			value_key_to_code[key] = code
		end
	end
	PROVIDED_CODES = nil
	return 'code', {
		type = 'input',
		name = L["Code"],
		desc = L["Enter a LibDogTag-3.0 code tag. You can type /dog into your chat for help."],
		get = function(info)
			return LibDogTag:CleanCode(PitBull4.Options.GetTextLayoutDB().code)
		end,
		set = function(info, value)
			PitBull4.Options.GetTextLayoutDB().code = LibDogTag:CleanCode(value)
			
			PitBull4.Options.UpdateFrames()
		end,
		multiline = true,
	}, 'default_codes', {
		type = 'select',
		name = L["Code"],
		desc = L["Some codes provided for you."],
		get = function(info)
			local code = PitBull4.Options.GetTextLayoutDB().code
			for k, v in pairs(value_key_to_code) do
				if v == code then
					return k
				end
			end
			return ""
		end,
		set = function(info, value)
			PitBull4.Options.GetTextLayoutDB().code = value_key_to_code[value]
			
			PitBull4.Options.UpdateFrames()
		end,
		values = values,
	}, 'help', {
		type = 'execute',
		name = L["DogTag help"],
		desc = L["Click to pop up helpful DogTag documentation."],
		func = function()
			LibDogTag:OpenHelp()
		end,
	}
end)
